import java.net.*;
import java.io.*;

public class PortMapper extends Thread{

	static Socket sock = null;
	static PrintWriter out = null;
	static BufferedReader in = null;
	static String telpass, opass, device, start, end, proto, forward;
	

	public static void main(String[] args) {		
		if( args.length == 8 ) {
			BufferedReader stdIn = new BufferedReader( new InputStreamReader(System.in) );
			InputHandler handler = null;
			telpass = (args[0]).trim();
			opass = (args[1]).trim();
			device = (args[2]).trim();
			start = (args[3]).trim();
			end = (args[4]).trim();
			proto = (args[5]).trim();
			forward = (args[6]).trim();
			String router = (args[7]).trim();
			String commandf = "nat inbound add " + device + " " + start + "/" + proto + " " + forward;
			String commandt = "nat inbound add " + device + " " + end + "/" + proto + " " + forward;
			System.out.println("I will try to connect to " + router);
			System.out.println("with TelnetPassword: "+telpass+ " Exit User Mode Password: "+opass);
			System.out.println("The following are the commands I will enter");
			System.out.println(commandf);
			System.out.println("to");
			System.out.println(commandt);
			try {
				
				while(true) {
					System.out.println("are you sure? (y/n)");
					String input = stdIn.readLine();
					if( input.toLowerCase().equals("y"))
						break;
					else if( input.toLowerCase().equals("n") ) {
						stdIn.close();
						System.exit(1);
					}
				}
					
		
			
				sock = new Socket(router, 23);
				out = new PrintWriter(sock.getOutputStream(), true);
				in = new BufferedReader(new InputStreamReader( sock.getInputStream() ) );
				System.out.println("connection success");
			}
			catch (UnknownHostException e) {
				System.out.println("Unknow Host: ");
				System.exit(1);
			}
			catch(IOException e) {
				System.out.println("IO Error");
				System.exit(1);
			}
			PortMapper p = new PortMapper(sock, out, in, telpass, opass, device, start, end, proto, forward);
			p.start();
			handler = new InputHandler("server", p, in);
			handler.start();		
		}
		else {
			System.out.println("wrong number of arguments!!");
			System.out.println("Useage: java PortMapper telnetpass exit_user_mode_pass device_name start_port end_port protocol forward_address, router_address");
			System.out.println("eg : java PortMapper adsl asus ppp_device 0 65535 udp 192.168.1.100 192.168.1.1");
		}
	}
		
	
	public PortMapper(Socket sock, PrintWriter out, BufferedReader in, String telpass, String opass, String device, String start, String end, String proto, String forward ) {
		this.sock = sock;
		this.out = out;
		this.in = in;
		this.telpass = telpass;
		this.opass = opass;
		this.device = device;
		this.start = start;
		this.end = end;
		this.proto = proto;
		this.forward = forward;
	}
	
	public void run() {
		
		BufferedReader stdIn = new BufferedReader( new InputStreamReader(System.in) );
		int userInput;
		
		try {
			
			out.println(telpass);
			out.print("9");
			out.println(opass);
			out.println(" ");
			int count = 0;
			for(int i = Integer.parseInt(start); i<= Integer.parseInt(end); i++) {
				count ++;
				out.println("nat inbound add " + device + " " + i +"/" + proto + " " + forward);
				if ( count > 10000 ) {
					out.println("config save");
					count = 0;
				}
			}
			out.println("config save");
			out.println("user");
			
			userInput = stdIn.read();
			
			stdIn.close();		
			out.close();
			in.close();
			sock.close();
		}
		catch(IOException e) {
			System.out.println("IOException");
		}
	}
	
	public void printText(String t) {
		System.out.println(t);
	}
}